Program Fractal;

Uses Graph, CRT, DOS, MOUSE;

Type

  NOME_ARQUIVO = String [12];

Const

  ENTER = 13;
  ESC = #27;
 PathToDrivers = '.';

Var

  palette: Array [1 .. 256, 1 .. 3] of Char;

  Arquivo: NOME_ARQUIVO;
	Driver, Mode: Integer;

Procedure Tela_Principal;

Const

  VERMELHO = 4;
  VERDE = 2;

Procedure MOLDURA (X1,Y1,X2,Y2,TIPO:Integer);

Var

  I: Integer;

Begin
  GotoXY (X1,Y1);
  Case TIPO of
    1 : Write (#201);
    2 : Write (#177);
    3 : Write (#214);
    4 : Write (#213);
    5 : Write (#176);
    6 : Write (#042);
    7 : Write (#178);
    8 : Write (#219)
  End;
  GotoXY (X2,Y1);
  Case TIPO of
    1 : Write (#187);
    2 : Write (#177);
    3 : Write (#183);
    4 : Write (#184);
    5 : Write (#176);
    6 : Write (#042);
    7 : Write (#178);
    8 : Write (#219)
  End;
  GotoXY (X1,Y2);
  Case TIPO of
    1 : Write (#200);
    2 : Write (#177);
    3 : Write (#211);
    4 : Write (#212);
    5 : Write (#176);
    6 : Write (#042);
    7 : Write (#178);
    8 : Write (#219)
  End;
  GotoXY (X2,Y2);
  Case TIPO of
    1 : Write (#188);
    2 : Write (#177);
    3 : Write (#189);
    4 : Write (#190);
    5 : Write (#176);
    6 : Write (#042);
    7 : Write (#178);
    8 : Write (#219)
  End;
  For I:=(X1+1) To (X2-1) Do
    Begin
      GotoXY (I,Y1);
      Case TIPO of
        1 : Write (#205);
        2 : Write (#177);
        3 : Write (#196);
        4 : Write (#205);
        5 : Write (#176);
        6 : Write (#042);
        7 : Write (#178);
        8 : Write (#219)
      End;
      Gotoxy (I,Y2);
      Case TIPO of
        1 : Write (#205);
        2 : Write (#177);
        3 : Write (#196);
        4 : Write (#205);
        5 : Write (#176);
        6 : Write (#042);
        7 : Write (#178);
        8 : Write (#219)
      End;
    End;
  For I:=(Y1+1) To (Y2-1) Do
    Begin
      Gotoxy (X1,I);
      Case TIPO of
        1 : Write (#186);
        2 : Write (#177);
        3 : Write (#186);
        4 : Write (#179);
        5 : Write (#176);
        6 : Write (#042);
        7 : Write (#178);
        8 : Write (#219)
      End;
      Gotoxy (X2,I);
      Case TIPO of
        1 : Write (#186);
        2 : Write (#177);
        3 : Write (#186);
        4 : Write (#179);
        5 : Write (#176);
        6 : Write (#042);
        7 : Write (#178);
        8 : Write (#219)
      End
    End;
End;

Begin

  ClrScr;

  TextColor (VERMELHO);
  Moldura (1, 1, 80, 3, 3);
  GotoXY (18, 2);
  Write ('Fractais do conjunto de Julia e MendelBrot');

  TextColor (VERDE);
  Moldura (30, 6, 50, 22, 1);
  GotoXY (36, 5);
  Write ('Arquivos');

  TextColor (VERDE);
  Gotoxy (1, 24);
  Write ('UFPR Carlos Fernando B. C.');

  TextBackGround (VERMELHO);
  TextColor (VERDE);
  GotoXY (50, 7);
  Write ('S');
  GotoXY (50, 21);
  Write ('D');
  Gotoxy (31, 6);
  Write ('X');
  Gotoxy (47, 22);
  Write ('Ok');

  TextBackGround (BLACK);

End;

Procedure Escolhe_Arquivo (Var Arquivo: NOME_ARQUIVO);

Type DIRETORIO = Array [1 .. 50] of NOME_ARQUIVO;

Var

  Fractais: DIRETORIO;

  Indice,
  Posicao,
  Inicio: Byte;

  MouseX, MouseY,
  MouseXAnt, MouseYAnt: Integer;

  Botao,
  BotaoAnt: Word;

  Caracter: Char;

Procedure Pega_Entrada_Fractais (Var Fractais: DIRETORIO; Var Indice: Byte);

Var

  Atributo: Word;
  Arquivo: SearchRec;

Begin

  Indice := 1;
  FindFirst ('*.FRC', Atributo, Arquivo);

  If (DosError <> 0) Then Begin { Erro }
    Indice := 0;
    Exit
  End
  Else Begin
    Fractais [Indice] := Arquivo.Name;
    While (DosError = 0) do Begin
      Inc (Indice);
      FindNext (Arquivo);
      Fractais [Indice] := Arquivo.Name;
    End;
    Dec (Indice);
  End;
End;

Procedure Limpa_Espaco_Arquivos;

Var

  Contador: Byte;

Begin

  For Contador := 7 to 21 do Begin
    GotoXY (31, Contador);
    Write (' ':18);
  End;

End;

Procedure Mostra_Nomes (Fractais: DIRETORIO; Indice, Posicao, Inicio: Byte);

Var

  Contador: Byte;

Begin

  Contador := Inicio;
  Repeat
    GotoXY (34, 6 + Contador - Inicio + 1);

    TextColor (5);

    If (Contador = Posicao) Then 
      TextColor (15);

    Write (Fractais [Contador]:12);

    Inc (Contador);
  Until (Contador - Inicio = 15) or (Contador - 1 = Indice);

End;

Begin
  Pega_Entrada_Fractais (Fractais, Indice);

  If (Indice = 0) Then Begin
    TextColor (7);
    ClrScr;
    Write ('Erro: Nao ha nenhum arquivo de fractal.');
    Halt (0);
  End;

  Limpa_Espaco_Arquivos;

  Posicao := 1;
  Inicio := 1;
  Mostra_Nomes (Fractais, Indice, Posicao, Inicio);

  SetGraphicsCursor (0, 0, Seta);
  EnableMouse;
  ReadMouse (MouseXAnt, MouseYAnt, BotaoAnt);

  Repeat
    Caracter := ' ';
    Repeat
      ReadMouse (MouseX, MouseY, Botao);
      If (KeyPressed) Then
        Caracter := Readkey;
    Until (MouseX <> MouseXAnt) or
          (MouseY <> MouseYAnt) or
          (Botao <> BotaoAnt) or
          (Caracter <> ' ');

    MouseXAnt := MouseX;
    MouseYAnt := MouseY;
    BotaoAnt := Botao;

    If (MouseX div 8 = 49) and (MouseY div 8 = 6) and (Botao = 1) or
       (Caracter = '8') Then Begin
      If (Posicao > 1) Then
        Dec (Posicao);
      If (Posicao < Inicio) Then
        Dec (Inicio);
      Limpa_Espaco_Arquivos;
      Mostra_Nomes (Fractais, Indice, Posicao, Inicio);
      SetCursorLocation (MouseX, MouseY);
    End;
    If (MouseX div 8 = 49) and (MouseY div 8 = 20) and (Botao = 1) or
       (Caracter = '2') Then Begin
      If (Posicao < Indice) Then
        Inc (Posicao);
      If (Posicao > Inicio + 14) Then
        Inc (Inicio);
      Limpa_Espaco_Arquivos;
      Mostra_Nomes (Fractais, Indice, Posicao, Inicio);
      SetCursorLocation (MouseX, MouseY);
    End;
    If (MouseX div 8 = 30) and (MouseY div 8 = 5) and (Botao = 1) or
      (Botao = 2) or (Caracter = ESC) Then Begin
      TextColor (7);
      DisableMouse;
      ClrScr;
      Halt (0);
    End;
  Until (MouseX div 8 = 46) and (MouseY div 8 = 21) and (Botao = 1) or
        (MouseX div 8 = 47) and (MouseY div 8 = 21) and (Botao = 1) or
        (Caracter = Chr (ENTER));
  DisableMouse;

  Arquivo := Fractais [Posicao];
End;

{ Mostra_Imagem: Coloca no video uma imagem gravada em arquivo.
  Recebe: Um arquivo texto.
  Retorna: Nada }

Procedure Mostra_Imagem (Arquivo: NOME_ARQUIVO);

  { Pow: Retorna 2^Expoente.
    Recebe: Expoente.
    Retorna: 2^Expoente. }

Const

  BEEP = 7;

  MaxX = 640;
  MaxY = 480;

Var

  Arq: Text;

  Bit,
  Teste: Byte;

  Repeticao,
  Cor,
  Posic: Integer;

  Caract: Char;

  X, Y: Integer;

Function Pow (Num, Expoente: Integer): Integer;

Begin

 If (Expoente = 0) Then
    Pow := 1
  Else
    Pow := Num * Pow (Num, Expoente-1);

End;

Procedure Muda_Cor;

Var

  Coluna,
  Linha: Integer;
  Cor: Byte;

Begin

  For Coluna := 0 to 480 do
    For Linha := 0 to 640 do
      Begin
        Cor := GetPixel (Linha, Coluna);
        PutPixel (Linha, Coluna, Cor mod 64);
      End;

End;


(* Muda_64_Tons_Cinza_Hi: muda as 64 primeiras cores da palete dos modos HI
   para os 64 tons possiveis de cinza.
   Recebe: Nada;
   Retorna: Nada; *)

Procedure BrincaPalette;

Var

  cont, cont2: Integer;
  tecla: Char;
  prim: Array [1 .. 3] of Char;
  cor: Integer;
  tempo: Integer;
  sentido: Boolean;

Begin
  sentido := TRUE;
  tempo:=100;
  For cont := 1 to 256 do Begin
    palette [cont, 1] := char (cont);
    palette [cont, 2] := char (cont);
    palette [cont, 3] := char (cont);
  End;
  Repeat
    if (keypressed) Then Begin
      tecla := ReadKey;
      case tecla of
      '0': Begin
             Repeat Until Keypressed;
             tecla := ReadKey;
             tecla := chr (0);
           End;
      '-': Begin
             If (tempo < 500) Then Tempo := Tempo + 10
                              Else Write (chr(BEEP));
           End;
      '+': Begin
             If (tempo > 0) Then Tempo := Tempo - 10
                                 Else Write (chr(BEEP));
           End;
      ' ': Begin
             If (sentido) Then Sentido:=FALSE
                          Else Sentido:=TRUE;
           End;
      '1': Begin
             For cont := 1 to 64 do Begin
               palette [cont, 1] := char (cont);
               palette [cont, 2] := chr (0);
               palette [cont, 3] := chr (0);
             End;
             For cont := 64 to 128 do Begin
               palette [cont, 1] := chr (0);
               palette [cont, 2] := char (cont - 64);
               palette [cont, 3] := chr (0);
             End;
             For cont := 128 to 192 do Begin
               palette [cont, 1] := chr (0);
               palette [cont, 2] := chr (0);
               palette [cont, 3] := char (cont - 128);
             End;
             For cont := 192 to 256 do Begin
               palette [cont, 1] := char (cont - 192);
               palette [cont, 2] := char (cont - 192);
               palette [cont, 3] := char (cont - 192);
             End;
           End;
      '2': Begin
             For cont := 1 to 256 do Begin
               palette [cont, 1] := char (cont);
               palette [cont, 2] := char (256 - cont);
               palette [cont, 3] := char (cont + cont mod 64);
             End;
           End;
       '3': Begin
       	      For cont := 1 to 256 do Begin
                cont2 := cont and 63;
		if((cont and 64) <> 0) Then cont2:=63-cont;
		palette[cont][1]:=chr (cont2);
		palette[cont][2]:=chr (cont2*cont2 div 63);
		cont2:=(cont shr 1) and 63;
		if(cont and 128 <> 0) Then cont2 := 63 - Cont2;
		palette[Cont][3]:=Chr (Cont2);
              End;
            End;
       '4': Begin
              For cont := 1 to 256 do Begin
                if (odd (cont)) Then Begin
                  palette [cont, 1] := char (cont);
                  palette [cont, 2] := char (256 - cont);
                  palette [cont, 3] := char (cont + cont mod 64);
                End
                Else Begin
                  palette [cont, 1] := char (cont + 2);
                  palette [cont, 2] := char (256 - cont + 2);
                  palette [cont, 3] := char (cont + cont mod 64);
                End;
              End;
            End;
       else Begin
              For cont := 1 to 256 do Begin
                palette [cont, 1] := char (cont);
                palette [cont, 2] := char (cont);
                palette [cont, 3] := char (cont);
              End;
            End;
       End;
     End;
    Asm
      Push ES
      Push DX
      Push AX
      Push BX
      Push CX
      Push DX
      Mov AX, DS
      Mov ES, AX
      Lea DX, palette
      Mov BX, 0
      Mov CX, 256
      Mov AX, $1012
      Int 10h
      Pop DX
      Pop CX
      Pop BX
      Pop AX
      Pop DX
      Pop ES
    End;
    if (Sentido) Then Begin
      prim [1] := palette [1] [1];
      prim [2] := palette [1] [2];
      prim [3] := palette [1] [3];
      For cont := 1 to 255 do Begin
        palette [cont, 1] := palette [cont + 1, 1];
        palette [cont, 2] := palette [cont + 1, 2];
        palette [cont, 3] := palette [cont + 1, 3];
      End;
      palette [256, 1] := prim [1];
      palette [256, 2] := prim [2];
      palette [256, 3] := prim [3];
    End
    Else Begin
      prim [1] := palette [256] [1];
      prim [2] := palette [256] [2];
      prim [3] := palette [256] [3];
      For cont := 255 downto 1 do Begin
        palette [cont + 1, 1] := palette [cont, 1];
        palette [cont + 1, 2] := palette [cont, 2];
        palette [cont + 1, 3] := palette [cont, 3];
      End;
      palette [1, 1] := prim [1];
      palette [1, 2] := prim [2];
      palette [1, 3] := prim [3];
    End;
    delay (tempo);
  Until (tecla = ESC);
End;


Begin

  Posic := 0;
  Cor := -1;
  Repeticao := -1;

  Assign (Arq, Arquivo);
  Reset (Arq);

    Driver:=9;
  Mode:=2;
  initGraph(Driver, Mode, PathToDrivers);


  Read (Arq, Caract);

  Bit := Ord (Caract);

  X := -1;
  While (X <= MaxX) do Begin
    Inc (X);

    Y := -1;
    While (Y <= MaxY) do Begin
      Inc (Y);

      If (Repeticao < 0) Then Begin

        Inc (Posic);
        If (Posic = 9) Then Begin
          Posic := 1;
          Read (Arq, Caract);
          Bit := Ord (Caract);
        End;

        Teste := Pow (2, Posic - 1);

        If ((Bit and Teste) = Teste) Then Begin
          Read (Arq, Caract);
          Repeticao := Ord (Caract);
          Read (Arq, Caract);
          Cor := Ord (Caract);
        End
        Else  Begin
          Read (Arq, Caract);
          Cor := Ord (Caract);
          Repeticao := -1;
        End;

      End;

     PutPixel (x, y, cor);

      Dec (Repeticao)

    End

  End;

  Close (Arq);

  Write (Chr (BEEP));

  Caract := ReadKey;

  BrincaPalette;

  CloseGraph;

End;


Begin

Repeat
  Tela_Principal;
  Escolhe_Arquivo (Arquivo);
  Mostra_Imagem (Arquivo);
Until FALSE;

End.
